package com.example.flutter_android_connection_api;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.KeyguardManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.PowerManager;
import android.view.WindowManager;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import io.flutter.embedding.android.FlutterActivity;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

/** FlutterAndroidConnectionApiPlugin */
public class FlutterAndroidConnectionApiPlugin extends FlutterActivity implements FlutterPlugin, MethodCallHandler, ActivityAware {
  private MethodChannel channel;
  private Context context;
  private static final String channelName = "flutter_android_connection_api_channel";


  private void setup(FlutterAndroidConnectionApiPlugin plugin, BinaryMessenger binaryMessenger) {
    plugin.channel = new MethodChannel(binaryMessenger, channelName);
    plugin.channel.setMethodCallHandler(plugin);

    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O_MR1)
    {
      setShowWhenLocked(true);
      setTurnScreenOn(true);
      System.out.println("TESTED");
      setVisible(true);
      KeyguardManager keyguardManager = (KeyguardManager) getSystemService(Context.KEYGUARD_SERVICE);
      if(keyguardManager!=null)
        keyguardManager.requestDismissKeyguard(this, null);
    }
    else
    {
      getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON|
              WindowManager.LayoutParams.FLAG_DISMISS_KEYGUARD|
              WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED|
              WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON);
    }

    //plugin.synth = new Synth();
    //TODO plugin.synth.start();

  }


  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    context=flutterPluginBinding.getApplicationContext();
    setup(this, flutterPluginBinding.getBinaryMessenger());
  }




  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else if (call.method.equals("testChannelCall")) {
      result.success("Moin Franz");
      startMainActivity();
    } else {
      result.notImplemented();
    }
    System.out.println(call.method+"   was called");
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }



  private void startMainActivity() {

    //Intent launchIntent = getPackageManager().getLaunchIntentForPackage("com.example.alarm_page");
    // if (launchIntent != null) {
    //      startActivity(launchIntent);//null pointer check in case package name was not found
    //    }

//    System.out.println(context);
//    PowerManager powerManager = (PowerManager) context.getSystemService(POWER_SERVICE);
//    PowerManager.WakeLock  wakeLock = powerManager.newWakeLock(PowerManager.FULL_WAKE_LOCK |
//            PowerManager.ACQUIRE_CAUSES_WAKEUP |
//            PowerManager.ON_AFTER_RELEASE, "appname::WakeLock");
//    wakeLock.acquire(10*60*1000L /*10 minutes*/);
//    wakeLock.release();

    Intent intent = FlutterAndroidConnectionApiPlugin.withNewEngine().initialRoute("/alarm").build(context);
    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
    context.startActivity(intent);

  }

  @Override
  public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {

  }

  @Override
  public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {

  }

  @Override
  public void onDetachedFromActivity() {

  }



}
